%global provider	github
%global provider_tld	com
%global project		purpleidea
%global repo		mgmt
%global provider_prefix	%{provider}.%{provider_tld}/%{project}/%{repo}
%global commit		ccb0e55d5acc72431060693a8d726e4221c9d043
%global shortcommit	%(c=%{commit}; echo ${c:0:7})

%define debug_package %{nil}

Name:		mgmt
Version:	0.0.26
Release:	0.2.git%{shortcommit}%{?dist}
Summary:	A next generation config management prototype!
License:	GPLv3+
URL:		https://%{provider_prefix}
Source0:	https://%{provider_prefix}/tarball/%{shortcommit}/%{project}-%{repo}-%{shortcommit}.tar.gz

# graphviz should really be a "suggests", since technically it's optional
Requires: graphviz

# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:	%{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires:	golang-x-tools-stringer
BuildRequires:	golang-x-tools-goyacc
BuildRequires:	nex
BuildRequires:	ragel-compat
BuildRequires:	git-core
BuildRequires:	mercurial
BuildRequires:	libvirt-devel
BuildRequires:	libxml2-devel
BuildRequires:	augeas-devel
BuildRequires:	systemd-rpm-macros

ExclusiveArch:	%{go_arches}

%description
A next generation config management prototype!

%prep
%setup -q -n %{project}-%{repo}-%{shortcommit}

%build
# Adding manual steps to avoid PKGNAME empty issue
go list . || true
go mod tidy
go list .
# Adapting program name extraction to github tarball strucuture
sed -i -e 's/cut -f1/cut -f2/' Makefile
# Forcing version
export SVERSION=%{version}
# Fixing systemd unit file
sed -i -e 's/systemd-networkd\.service/network-online.target/g' misc/mgmt.service
# Actual build
make build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_unitdir}/
install -pm 0644 misc/mgmt.service %{buildroot}/%{_unitdir}/

# install the binary
mkdir -p %{buildroot}/%{_bindir}
install -m 0755 mgmt %{buildroot}/%{_bindir}/mgmt

# profile.d bash completion
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install misc/bashrc.sh -m 0755 %{buildroot}%{_sysconfdir}/profile.d/mgmt.sh

# etc dir
mkdir -p %{buildroot}%{_sysconfdir}/mgmt/
install -m 0644 misc/example.conf %{buildroot}%{_sysconfdir}/mgmt/mgmt.conf

%files
%attr(0644, root, root) %{_sysconfdir}/profile.d/mgmt.sh
%{_bindir}/mgmt
%{_sysconfdir}/mgmt/*
%{_unitdir}/mgmt.service

# https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Documentation
# Please add docs one per line in alpha order to avoid diff churn.
%doc AUTHORS
%doc COPYING
%doc COPYRIGHT
%doc TODO.md
%doc README.md
%doc THANKS
%doc examples/*

%changelog
* Mon Jul 08 2024 Giuseppe Ragusa <giuseppe.ragusa@hotmail.com> 0.0.26-0.2.gitccb0e55
- Upgraded to latest commit and rebuilt for Fedora 40

* Sat Apr 20 2024 Giuseppe Ragusa <giuseppe.ragusa@hotmail.com> 0.0.26-0.1.git453cd44
- First attempt at building using spec from builtin template, adapted for Fedora 38 and mock

